<template>
  <div class="pages-index" style="background-color: #3b4359">
    <NavBar class="no-bg">
      <template slot="left">
        <BurgerNav />
      </template>
      <template slot="right">
        <AddAccount v-if="!current_user" />
        <nuxt-link v-else :to="localePath('/profile')" class="navbar__avatar">
          <Avatar :user="current_user" />
        </nuxt-link>
      </template>
    </NavBar>
    <div class="main-header">
      <client-only>
        <swiper class="main-header__slider" :options="swiperOptions">
          <swiper-slide v-for="(item, index) in sliderHome" :key="index">
            <blur-hash-image
              v-if="item.blurhash"
              width="400"
              height="300"
              :hash="item.blurhash"
              :src="`/storage/${item.url}`"
            />
            <img v-else :src="`/storage/${item.url}`" />
          </swiper-slide>
        </swiper>
      </client-only>
      <!-- <Nav :with-links="true" /> -->
      <div v-if="page" class="container-center">
        <MainContainer>
          <div class="main-header__row">
            <div class="main-header__left">
              <div class="main-header__title">
                {{ getBlock('header').title }}
              </div>
              <div
                class="main-header__text"
                v-html="getBlock('header').content"
              ></div>
              <div class="main-header__login">
                <div>
                  <Button :to="localePath('/auth/register')">
                    {{ $t('auth.register') }}
                  </Button>
                </div>
                <div>
                  <Button :to="localePath('/auth/login')" variant="dark">
                    {{ $t('auth.login') }}
                  </Button>
                </div>
                <!-- <Button class="auth__google" variant="light">
                  <svg-icon name="google" />
                  <span>Login</span>
                </Button> -->
              </div>

              <div v-if="getBlock('header-bottom').active">
                <div class="main-header__title">
                  {{ getBlock('header-bottom').title }}
                </div>
                <div
                  class="main-header__text"
                  v-html="getBlock('header-bottom').content"
                ></div>
                <div class="main-header__link">
                  <div>
                    <Button
                      v-if="
                        !getBlock('header-token-buy').menu_link.includes('http')
                      "
                      :to="localePath(getBlock('header-token-buy').menu_link)"
                      variant="success"
                    >
                      {{ getBlock('header-token-buy').menu_label }}
                    </Button>
                    <a
                      v-else
                      :href="getBlock('header-token-buy').menu_link"
                      target="_blank"
                    >
                      <Button variant="success" @click="return false">
                        {{ getBlock('header-token-buy').menu_label }}
                      </Button>
                    </a>
                  </div>
                  <div>
                    <Button
                      :to="localePath(getBlock('header-readmore').menu_link)"
                      variant="white-opacity"
                    >
                      {{ getBlock('header-readmore').menu_label }}
                    </Button>
                  </div>
                </div>
              </div>
            </div>

            <div class="main-header__right hide-mobile">
              <MobileApp position="header" />
            </div>
          </div>
        </MainContainer>
      </div>
    </div>

    <div v-if="page" class="main-section">
      <div class="container">
        <template v-if="page.pages_contents[0]">
          <div class="main-section__title">
            {{ page.pages_contents[0].title }}
          </div>
          <div
            class="main-section__description"
            v-html="page.pages_contents[0].content"
          ></div>
        </template>

        <MainItem
          v-if="getBlock('search').active"
          :title="getBlock('search').title"
          :content="getBlock('search').content"
          :icons="[{ icon: 'marker', class: 'style-1' }]"
          :images="[
            { src: require('@/assets/images/main/1.jpg') },
            { src: require('@/assets/images/main/2.jpg'), class: 'style-1' }
          ]"
        />

        <MainItem
          v-if="getBlock('request').active"
          class="main-item__revers"
          :title="getBlock('request').title"
          :content="getBlock('request').content"
          :icons="[{ icon: 'clock', class: 'style-2' }]"
          :images="[
            { src: require('@/assets/images/main/3.jpg') },
            { src: require('@/assets/images/main/4.png'), class: 'style-5' }
          ]"
        />

        <MainItem
          v-if="getBlock('chat').active"
          :title="getBlock('chat').title"
          :content="getBlock('chat').content"
          :icons="[{ icon: 'chat', class: 'style-3' }]"
          :images="[
            { src: require('@/assets/images/main/5.jpg') },
            { src: require('@/assets/images/main/6.jpg'), class: 'style-1' }
          ]"
        />

        <MainItem
          v-if="getBlock('purchase').active"
          class="main-item__block"
          type="lines"
          :title="getBlock('purchase').title"
          :content="getBlock('purchase').content"
          :icons="[{ icon: 'wallet', class: 'style-1' }]"
          :images="[
            { src: require('@/assets/images/main/7.jpg') },
            { src: require('@/assets/images/main/8.jpg'), class: 'style-2' },
            { src: require('@/assets/images/main/9.jpg'), class: 'style-3' }
          ]"
          :links="[
            {
              title: getBlock('purchase').menu_label,
              to: localePath(getBlock('purchase').menu_link)
            }
          ]"
        />

        <MainItem
          v-if="getBlock('download').active"
          :title="getBlock('download').title"
          :content="getBlock('download').content"
          :icons="[{ icon: 'download', class: 'style-4' }]"
          :images="[
            { src: require('@/assets/images/main/10.jpg') },
            { src: require('@/assets/images/main/11.jpg'), class: 'style-4' }
          ]"
          :links="[
            {
              title: getBlock('download').menu_label,
              to: localePath(getBlock('download').menu_link),
              class: 'style-1'
            }
          ]"
        />
        <MobileApp />
      </div>
    </div>

    <section class="main-footer">
      <div class="container">
        <Footer />
      </div>
    </section>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  useAsync,
  useMeta,
  computed
} from '@nuxtjs/composition-api'

import { FullPageFragment, PageContentBlockFragment } from '~/sdk/types'

import useSeo from '@/hooks/seo'

import MobileApp from '@/components/app/MobileApp.vue'
import Footer from '@/components/app/Footer.vue'
import useGetLocales from '@/hooks/get-locales'
import Button from '@/components/ui/Button.vue'
import Nav from '@/components/app/Nav.vue'

import NavBar from '@/components/app/NavBar.vue'
import BurgerNav from '@/components/ui/BurgerNav.vue'
import AddAccount from '@/components/ui/AddAccount.vue'
import Avatar from '@/components/ui/Avatar.vue'

import { useGetPageQuery, useCoverImagesQuery } from '~/sdk/hooks'

import MainItem from '@/components/ui/MainItem.vue'
import MainContainer from '@/components/ui/MainContainer.vue'

import { Swiper, SwiperSlide, directive } from 'vue-awesome-swiper'
import 'swiper/css/swiper.css'

export default defineComponent({
  layout: 'home',
  name: 'HomePage',
  components: {
    MainItem,
    MobileApp,
    Nav,
    Footer,
    Button,
    MainContainer,

    NavBar,
    BurgerNav,
    AddAccount,
    Avatar,

    Swiper,
    SwiperSlide
  },
  directives: {
    swiper: directive
  },

  head: {},
  setup(_, { root }) {
    const current_user = computed(() => root.$accessor.auth.user)
    const { result } = useCoverImagesQuery()
    const sliderHome = computed(() => result.value?.cover_images || [])

    const { app, error } = useContext()
    const { onResult, loading } = useGetPageQuery({
      slug: '/',
      locales: useGetLocales(app.i18n)
    })

    const meta = useMeta()
    const page = useAsync<FullPageFragment>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            if (!result?.data?.pages?.[0]?.pages_contents?.[0]) {
              error({ statusCode: 404 })
              return resolve()
            }

            const page = result.data.pages[0]
            useSeo(page, app.$accessor.seo.default, meta, app.i18n.locale)
            resolve(page)
          })
        )
    )

    if (process.client) {
      onResult(result => {
        if (!result?.data?.pages?.[0]?.pages_contents?.[0]) {
          return error({ statusCode: 404 })
        }
        page.value = result.data.pages[0]
        useSeo(page.value, app.$accessor.seo.default, meta, app.i18n.locale)
      })
    }

    function getBlock(hash: string): PageContentBlockFragment {
      if (!page.value?.pages_contents?.[0])
        return {
          hash
        } as PageContentBlockFragment

      return (
        page.value.pages_contents[0].pages_contents_blocks.find(
          block => block.hash === hash
        ) ||
        ({
          hash,
          menu_link: ``,
          title: `block #${hash} is not defined`,
          content: `block #${hash} is not defined`
        } as PageContentBlockFragment)
      )
    }

    const swiperOptions = {
      allowTouchMove: false,
      effect: 'fade',
      speed: 2000,
      slidesPerView: 1,
      autoplay: { delay: 5500 },
      loop: false
    }

    return {
      current_user,
      page,
      loading,
      getBlock,
      sliderHome,
      swiperOptions
    }
  }
})
</script>

<style lang="scss" scoped>
.main-header {
  padding: 55px 0 30px 0;
  position: relative;
  z-index: 2;
  overflow: hidden;

  display: flex;
  flex-direction: column;
  flex-wrap: wrap;
  min-height: 100vh;

  @media (min-width: 1199.98px) {
    padding: 85px 0 60px 0;
  }

  .container-center {
    flex: 1;
    display: flex;
    align-items: center;
    > div {
      flex: 1;
      padding-left: 15px;
      padding-right: 15px;
    }
  }

  &__row {
    margin-top: 30px;
    @media (min-width: 1199.98px) {
      display: flex;
      align-items: flex-end;
      margin-top: 40px;
      margin-bottom: 70px;
      > * {
        flex: 0 0 50%;
      }
    }
  }

  @media (min-width: 1199.98px) {
    &__right {
      text-align: right;
    }
  }

  &__title {
    font-size: 35px;
    line-height: 40px;
    font-weight: 400;
    letter-spacing: -1.13px;
    color: #ffffff;
    margin-bottom: 10px;
    @media (min-width: 1199.98px) {
      font-size: 45px;
      line-height: 40px;
      margin-bottom: 20px;
    }
  }

  &__text {
    color: #ffffffad;
    font-size: 24px;
    line-height: 30px;
    margin-bottom: 36px;
    @media (min-width: 991.98px) {
      font-size: 30px;
      line-height: 36px;
      margin-bottom: 55px;
    }
    ::v-deep p {
      margin: 0;
      padding: 0;
    }
  }

  &__login {
    display: grid;
    grid-gap: 25px;
    margin-bottom: 25px;
    @media (min-width: 768px) {
      margin-bottom: 100px;
      margin-bottom: 75px;
      grid-auto-flow: column;
      grid-auto-columns: max-content;
    }
  }

  &__link {
    display: grid;
    grid-gap: 25px;
    @media (min-width: 768px) {
      grid-auto-flow: column;
      grid-auto-columns: max-content;
    }
  }

  &__sub {
    text-align: left;
    font-size: 18px;
    line-height: 21px;
    letter-spacing: 0px;
    color: #ffffff;
    margin-top: 30px;

    @media (min-width: 1199.98px) {
      margin-top: 0px;
    }
    a {
      text-decoration: underline;
    }
  }

  &__slider {
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    z-index: -1;
    opacity: 0.5;
    pointer-events: none;

    .swiper-slide {
      display: flex;

      &::v-deep {
        > div {
          flex: 1;
          display: flex;
          padding: 0 !important;
        }
        img {
          object-fit: cover;
        }
      }
      img {
        width: 100%;
        height: 100%;
        flex: none;
        object-fit: cover;
      }
    }
  }
}

.main {
  &-section {
    padding-top: 60px;
    padding-bottom: 60px;
    @media (min-width: 1199.98px) {
      padding-top: 130px;
      padding-bottom: 100px;
    }
    .container {
      max-width: 1440px;
      margin: 0 auto;
      padding-left: 30px;
      padding-right: 30px;
    }

    &__title {
      color: #ffffff;
      font-size: 45px;
      line-height: 45px;
      font-weight: bold;
      text-align: center;
      letter-spacing: -1.13px;
      margin-bottom: 30px;
      @media (min-width: 1199.98px) {
        font-size: 90px;
        line-height: 70px;
        letter-spacing: -2.25px;
      }
    }
    &__description {
      color: #9badd6;
      font-size: 24px;
      line-height: 33px;
      text-align: center;
      order: 3;
      margin-bottom: 60px;
      @media (min-width: 1199.98px) {
        font-size: 30px;
        line-height: 36px;
        max-width: 70%;
        margin: 0 auto 250px auto;
      }

      p {
        margin-bottom: 25px;
        margin-top: 0px;
        @media (min-width: 1199.98px) {
          margin-bottom: 35px;
        }
        &:last-child {
          margin-bottom: 0;
        }
      }
    }
  }
  &-footer {
    .container {
      max-width: 1440px;
      margin: 0 auto;
      padding-left: 30px;
      padding-right: 30px;
    }
  }
}
</style>
